(* -*- coding:utf-8; mode:sml; indent-tabs-mode:nil; c-basic-offset:3; -*- *)

datatype 'a seq = Cons of 'a * (unit -> 'a seq)

fun hdSeq (Cons (x, _)) = x
fun tlSeq (Cons (_, xs)) = xs

fun seqFrom i = Cons (i, fn () => seqFrom (i + 1))

fun filteredSeq p (Cons (x, xs)) =
   if p x then Cons (x, fn () => filteredSeq p (xs ()))
   else filteredSeq p (xs ())

fun sift a ns = filteredSeq (fn n => n mod a <> 0) ns

fun sieve (Cons (n, ns)) = Cons (n, fn () => sieve (sift n (ns ())))

val primes = sieve (seqFrom 2)

fun print_all ns =
   let val _ = print ((Int.toString (hdSeq ns)) ^ "\n")
   in print_all ((tlSeq ns) ())
   end

val _ = print_all primes
